UNIT FX;

INTERFACE

USES
    Dos,Crt1,Globals,Adlibu;

PROCEDURE FX_Init(m : BOOLEAN);
PROCEDURE FX_Inits(VAR m : FX_Type);
PROCEDURE FX_Walk;
PROCEDURE FX_Jump;
PROCEDURE FX_Shoot;
PROCEDURE FX_Pel;
PROCEDURE FX_Die(n : INTEGER;b : BOOLEAN);
PROCEDURE On_Timer;
PROCEDURE FX_Kill;
PROCEDURE FX_DrawSnd(n : BYTE);
PROCEDURE FX_EndGame(n,m : BYTE);
PROCEDURE Delay2(n : WORD);
PROCEDURE FX_On78;
PROCEDURE FX_Off78;

VAR
   Adlib : BOOLEAN;

CONST
     GenAddr : WORD = $388;
     MAXFs = 6;
     FXs : ARRAY[0..MAXFs] OF FX_Type =
           ( (r1 : 0;r2 : 0;r3 : 3;init : ($9,$2020,$0909,$f8f8,$ffff,$ff,0,0)),
             (r1 : 1;r2 : 1;r3 : 4;init : ($3,$2020,$0404,$ffff,$1f1f,$ff,1,3)),
             (r1 : 2;r2 : 5;r3 : 2;init : ($f,$202f,$0000,$f6f4,$ffff,$ff,$e,$3)),
             (r1 : 3;r2 : $b;r3 : $8;init : ($0,$2222,$0000,$fff6,$ff1f,$ff,$e,$203)),
             (r1 : 5;r2 : $a;r3 : $d;init : ($0,$2c2c,$0303,$ffff,$1919,$0,$9,$202)),
             (r1 : 4;r2 : $c;r3 : $9;init : ($0,$2323,$0000,$ffff,$1919,$0,$3,$0)),
             (r1 : 6;r2 : $13;r3 : $10;init : ($2,$2d2d,$0000,$f6f6,$ffff,$ff,$9,$202))
           );
     FX2 : ARRAY[0..14] OF FX_Type =
           ( (r1 : 7;r2 : $11;r3 : $14;init : ($2,$2622,$0000,$ffff,$1f1f,$0,$6,$1)),
             (r1 : 7;r2 : $14;r3 : $11;init : ($2,$2020,$0000,$f7f6,$ffff,$ff,$f,$3)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($0,$2c2c,$0000,$ffff,$1919,$0,$9,$303)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($b,$2828,$0000,$ffff,$1f1f,$0,$2,$103)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($3,$2222,$0000,$ffff,$1f1f,$0,$4,$201)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($2,$2121,$0000,$f55d,$ffff,$0,$d,$3)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($2,$2223,$0000,$f66f,$ffff,$ff,$2,$0)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($f,$2120,$0000,$f2ff,$15ff,$ff,$d,$0)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($1,$2222,$0,$f8f7,$ffff,$0,$0,$203)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($1,$2726,$0,$faf9,$ffff,$0,$0,$203)),
             (r1 : 7;r2 : $14;r3 : $11;init : ($1,$2625,$0,$f9f8,$ffff,$0,$0,$203)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($1,$2220,$0,$6463,$ffff,$0,$0,$203)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($1,$2421,$0,$f4ff,$1f1f,$0,$0,$201)),
             (r1 : 6;r2 : $13;r3 : $10;init : ($1,$2620,$0,$ffff,$1f1f,$0,$0,$1)),
             (r1 : 8;r2 : $15;r3 : $12;init : ($1,$2e22,$0,$ffff,$1f1f,$0,$c,$1))
           );

VAR
   n,m : INTEGER;

IMPLEMENTATION

PROCEDURE Delay2(n : WORD);
BEGIN
     DelayV := 0;
     WHILE DelayV < n DO;
END;

PROCEDURE FX_Inits(VAR m : FX_Type);
BEGIN
     WITH m DO IF Adlib THEN
     BEGIN
          SndOutput($b0+r1,init[0]);
          SndOutput($20+r2,lo(init[1]));
          SndOutput($20+r3,hi(init[1]));
          SndOutput($40+r2,lo(init[2]));
          SndOutput($40+r3,hi(init[2]));
          SndOutput($60+r2,lo(init[3]));
          SndOutput($60+r3,hi(init[3]));
          SndOutput($80+r2,lo(init[4]));
          SndOutput($80+r3,hi(init[4]));
          SndOutput($a0+r1,init[5]);
          SndOutput($c0+r1,init[6]);
          SndOutput($e0+r2,lo(init[7]));
          SndOutput($e0+r3,hi(init[7]));
          tick := 9000;
     END ELSE tick := 9000;
END;

PROCEDURE FX_Init(m : BOOLEAN);
BEGIN
     port[$61] := port[$61] OR 1;
     Adlib := (DetectAdlib <> -1) OR nosnd;
     IF Adlib THEN
     BEGIN
          IF nosnd THEN Messup_Port;
          FOR n := 0 TO 255 DO SndOutput(n,0);
          SndOutput($01,$20); {Wave Select Feature enable}
     END ELSE NoSound;
     FOR n := 0 TO MAXfs DO FX_Inits(FXs[n]);
END;

PROCEDURE FX_Kill;
BEGIN
     IF Adlib THEN
        FOR n := 0 TO 255 DO SndOutput(n,0)
     ELSE NoSound;
END;

PROCEDURE FX_DrawSnd(n : BYTE);
BEGIN
     IF Adlib THEN WITH FX2[13] DO
        IF n = 0 THEN
        BEGIN
             SndOutput($b0+r1,0);
             SndOutput($b0+r1,$21);
        END ELSE SndOutput($a0+r1,n);
END;

PROCEDURE FX_EndGame(n,m : BYTE);
BEGIN
     WITH FX2[12] DO
     BEGIN
          IF Adlib THEN
          BEGIN
               IF n < 3 THEN
               BEGIN
                    SndOutput($20+r3,m);
                    SndOutput($b0+r1,$01);
                    SndOutput($b0+r1,$21);
               END ELSE SndOutput($b0+r1,$01);
          END;
     END;
END;

PROCEDURE FX_Walk;
CONST
     doit : BOOLEAN = FALSE;
BEGIN
     WITH FXs[0] DO IF doit THEN IF Adlib THEN
     BEGIN
          SndOutput($b0+r1,init[0]);
          SndOutput($b0+r1,init[0] OR $20);
     END ELSE
     BEGIN
          Sound(100);
          Sound(65000);
     END;
     doit := NOT doit;
END;

PROCEDURE FX_Off78;
BEGIN
     IF Adlib THEN
     BEGIN
          SndOutput($40+$11,$ff);
          SndOutput($40+$14,$ff);
          SndOutput($40+$12,$ff);
          SndOutput($40+$15,$ff);
     END ELSE NoSound;
END;

PROCEDURE FX_On78;
BEGIN
     IF Adlib THEN
     BEGIN
          SndOutput($40+$11,$0);
          SndOutput($40+$14,$0);
          SndOutput($40+$12,$0);
          SndOutput($40+$15,$0);
     END;
END;

PROCEDURE FX_Jump;
BEGIN
     FXs[1].tick := 0;
     FXs[1].minor := -1;
     IF Adlib THEN SndOutput($b0+FXs[1].r1,$22);
END;

PROCEDURE FX_Pel;
BEGIN
     FXs[3].tick := 0;
     FXs[3].minor := -1;
     IF Adlib THEN SndOutput($b0+FXs[3].r1,$2d);
END;

PROCEDURE FX_Shoot;
BEGIN
     WITH FXs[2] DO IF Adlib THEN
     BEGIN
          SndOutput($b0+r1,init[0]);
          SndOutput($b0+r1,init[0] OR $20);
     END ELSE
     BEGIN
          Sound(300);
          Delay2(7);
          Sound(65000);
     END;
END;

PROCEDURE FX_Die(n : INTEGER;b : BOOLEAN);
BEGIN
     IF b THEN WITH FXs[4] DO
     BEGIN
          IF n < 168 THEN
          BEGIN
               IF Adlib THEN
               BEGIN
                    n := 230-n;
                    SndOutput($b0+r1,$20+((n*3) shr 8));
                    SndOutput($a0+r1,(n*3) and 255);
               END ELSE
               BEGIN
                    n := 230-n;
                    Sound(n*10);Sound(65000);Delay2(5);Sound(n*10);
               END;
          END ELSE IF Adlib THEN SndOutput($b0+r1,0) ELSE NoSound;
     END ELSE WITH FXs[5] DO IF Adlib THEN
     BEGIN
          tick := 0;
          minor := -1;
          SndOutput($b0+r1,$23);
     END;
END;

PROCEDURE On_Timer;
BEGIN
     WITH FXs[1] DO IF tick < 10 THEN
     BEGIN
          minor := (minor + 1) MOD 15;
          IF minor = 0 THEN
          BEGIN
               CASE tick OF
                 0..4 : IF Adlib THEN
                        BEGIN
                             SndOutput($20+r2,$25+tick);
                             SndOutput($20+r3,$25+tick);
                        END ELSE
                        BEGIN
                             Sound((tick+1)*50+400);
                        END;
                 5..9 : IF Adlib THEN
                        BEGIN
                             SndOutput($20+r2,$25+(8-tick));
                             SndOutput($20+r3,$25+(8-tick));
                        END ELSE
                        BEGIN
                             Sound((9-tick)*50+400);
                        END;
               END;
               Inc(tick);
               IF tick = 10 THEN
                  IF Adlib THEN SndOutput($b0+r1,$02)
                  ELSE NoSound;
          END;
     END;
     WITH FXs[3] DO IF tick < 29 THEN
     BEGIN
          minor := (minor + 1) MOD 5;
          IF minor = 0 THEN
          BEGIN
               Inc(tick);
               IF Adlib THEN
               BEGIN
                    SndOutput($a0+r1,tick*tick);
                    IF tick = 29 THEN SndOutput($b0+r1,$02);
               END ELSE
               BEGIN
                    Sound(((tick*tick) MOD 400)*2+300);
                    IF tick = 29 THEN NoSound;
               END;
          END;
     END;
     WITH FXs[5] DO IF (tick < 100) AND Adlib THEN
     BEGIN
          Inc(tick);
          CASE tick OF
             0..49 : SndOutput($a0+r1,tick*4);
             50..99 : SndOutput($a0+r1,tick*4);
             100 : SndOutput($b0+r1,$04);
          END;
     END;
END;

END.
