;
;       Bill's improved OUTCHIP.ASM
;

IDEAL
MODEL   tpascal

DATASEG

chip    dw      ?
bFailed DB      ?

CODESEG

PUBLIC  detectadlib, sndoutput, messup_port

;
;       Delay procedure -- Delay is stored in AX
;

DB      'HERE'

PROC    delayv  NEAR
        push    dx
        push    cx
        mov     dx,10
        xor     cx,cx
        cli
        mov     bx,ax
        mov     al,0b8h
        out     43h,al
        mov     ax,bx
        out     42h,al
        xchg    ah,al
        out     42h,al
wait1:
        dec     cx
        jnz     around1
        mov     [bFailed],1
        pop     cx
        pop     dx
        pop     ax
        pop     ax
        pop     ax
        mov     ax,-1
        sti
        retf
around1:in      al,42h
        xchg    ah,al
        in      al,42h
        xchg    ah,al
        or      ax,ax
        jns     wait1
failure:pop     cx
        pop     dx
        sti
        ret
ENDP    delayv


PROC    delay1  NEAR
        mov     ax,3
        call    delayv                          ; 3.3 microseconds (3)
        ret
ENDP    delay1

PROC    delay2  NEAR
        mov     ax,20
        call    delayv                          ; 23 microseconds (20)
        ret
ENDP    delay2

PROC    delay3  NEAR
        mov     ax,107
        call    delayv                          ; 80 microseconds (67)
        ret
ENDP    delay3

;
;       Check for an adlib board at DX
;

PROC    checkat NEAR
        mov     al,4
        out     dx,al
        inc     dx
        call    delay1                          ; Wait for adlib to accept the
                                                ; reg change
        mov     al,60h
        out     dx,al
        call    delay2                          ; Wait for adlib to accept the
                                                ; timer reset
        mov     al,80h
        out     dx,al
        call    delay2                          ; Reset the IRQ
        dec     dx

        in      al,dx
        mov     cx,ax                           ; Get value from status

        mov     al,2
        out     dx,al
        inc     dx
        call    delay1                          ; Timer register

        mov     al,255
        out     dx,al
        dec     dx
        call    delay2                          ; Set to 255

        mov     al,4
        out     dx,al
        inc     dx
        call    delay1                          ; Back to register 4

        mov     al,21h
        out     dx,al
        dec     dx
;        call    delay2

        call    delay3                          ; Wait for timer to increment
        in      al,dx
        mov     ch,al

        mov     al,60h
        out     dx,al
        call    delay2                          ; Wait for adlib to accept the
                                                ; timer reset
        mov     al,80h
        out     dx,al
        call    delay2                          ; Reset the IRQ

        and     cx,0e0e0h                       ; Strip the unused bits
        cmp     cx,0c000h
        jnz     failed
        clc
        ret
failed: stc
        ret
ENDP    checkat

PROC    detectadlib
        mov     [bFailed],0
        mov     dx,0388h
        call    checkat
        jnc     found
        mov     dx,0218h
        call    checkat
        jnc     found
        mov     dx,0288h
        call    checkat
        jnc     found
        mov     dx,0318h
        call    checkat
        jnc     found
        mov     ax,-1
        ret
found:  mov     ax,dx
        mov     [chip],ax
        ret
ENDP    detectadlib

PROC    sndoutput
        ARG     reg:WORD,value:WORD
        cmp     [bFailed],0
        jnz     @@Done

        mov     dx,[chip]
        mov     al,[BYTE reg]
        out     dx,al
        call    delay1
        inc     dx
        mov     al,[BYTE value]
        out     dx,al
        call    delay2
@@Done:
        ret
ENDP    sndoutput

PROC    messup_port
        mov     [chip],400h
        mov     [bFailed],1
        ret
ENDP
END

